// 1 Feb 2006 : Coding by Simone Mannori
//              basic examples from Comedi PDF and comedilib/demo/<sourcecode> 

// Computational function for Comedi data acquisition cards 
// 

//** -------------------------- COMEDI DIGITAL INPUT --------------------------------------

//**  Analog input block 
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <unistd.h>
#include <fcntl.h>
#include <ctype.h>
#include <sys/types.h>
#include <asm/types.h>

#include "scicos_block.h"  /* Specific for scicos block developement */
#include "machine.h"
#include <math.h>

/* Specific for Comedi Interface */
#include <comedilib.h>

#define Init           4   /* Initialization */ 
#define OutputUpdate   1
#define StateUpdate    2
#define Integration    0
#define Mode           9    /* Zero Crossing */
#define EventScheduler 3
#define Ending         5   

//** Comedi static structure inside block->work  
  typedef struct {
    int comedi_device ; //** 
    comedi_t *it      ; //** Comedi interface handler*/
    
    int subdev ; //** Comedi subdevice
    int chan   ; //** channel selection
  
  } ComediDigIn ;

void comedi_digital_input(scicos_block *block, int flag) 
{
  ComediDigIn *DIdata ; //** define the local datastructure 
  lsampl_t data   ; /* */
      
  switch(flag) {  
      
      case Init: //** Card and port init   
       *block->work = (ComediDigIn *) scicos_malloc(sizeof(ComediDigIn));
        if (*block->work  == NULL ) 
          { //** in case of error exit 
	    set_block_error(-16); return; //** --> Exit point  
          }
	DIdata = (ComediDigIn *) *block->work; //** map the local strucutre in the scicos_block user data  
       
        DIdata->it = comedi_open("/dev/comedi0"); /* */
        // code to check  
        if ( DIdata->it <= 0 ) {
         fprintf(stderr, "Comedi Digital Input not found. \n");
         exit(1);
          } else
         printf("Comedi Digital Input found!\n"); 
       
        DIdata->subdev = 2 ; // digital channel I/O
        DIdata->chan   = block->ipar[0] ; 
        comedi_dio_config(DIdata->it, DIdata->subdev, DIdata->chan, COMEDI_INPUT); //** configure as input 
       break; 
      
      case OutputUpdate:
        DIdata = (ComediDigIn *) *block->work ;
        comedi_dio_read( DIdata->it, DIdata->subdev, DIdata->chan, &data);
	block->outptr[0][0] = (double) data;
      break;
      
      case Ending:
          // comedi_close(it);
      break;	  
        
  } // close the switch
   
} // close the function 

